<template>
  <b-card
    title="Lista de actividades"
  >
        <div class="m-1">
          <b-row>

            <!-- Search -->
            <b-col
              cols="12"
              md="6"
              class="d-flex align-items-center justify-content-start mb-1 mb-md-0"
            >
              <b-form-input
                  v-model="searchQuery"
                  class="d-inline-block mr-1"
                  placeholder="Search..."
                />
            </b-col>
    
            <b-col
              cols="12"
              md="6"
            >
              <div class="d-flex align-items-center justify-content-end">
              
              </div>
            </b-col>
          </b-row>
        </div>
      <b-table
        :fields="fields"
        :items="activities"
        responsive
        :filter="searchQuery"
        class="mb-0"
        show-empty
        sticky-header
        empty-text="No se encontraron registros"
      >

        <!-- A virtual column -->
        <template #cell(index)="data">
          {{ data.item.id  }}
        </template>

        <template #cell(user_manager)="data">

            <b-avatar
              v-if="data.item.user_manager.image"
              class="mr-1" 
              size="lg"
              :src="baseURL+data.item.user_manager.image"
            />
            <b-avatar
              v-else
              class="mr-1" 
              size="lg"
      
            />
            {{ data.item.user_manager.name }} {{data.item.user_manager.last_name}}
      
        </template>

        <!-- A custom formatted column -->
        <template #cell(progress)="data">
          <b-progress
            :value="data.item.percentage_advance"
            max="100"
            height="7px"
            :variant="percentageVariant(data.item.percentage_advance)"
            striped
          />
          {{data.item.percentage_advance}}%
        </template>

        <template #cell(status)="data">
          <b-badge
            pill
            :variant="statusVariant(data.value.id)"
          >
            {{ data.value.name }}
          </b-badge>
        </template>

        <!-- A virtual composite column -->
        <!-- Column: Actions -->
          <template #cell(actions)="data">
            <b-dropdown
              variant="link"
              no-caret
            >

              <template #button-content>
                <feather-icon
                  icon="MoreVerticalIcon"
                  size="16"
                  class="align-middle text-body"
                />
              </template>
              <b-dropdown-item :to="{ name: 'apps-project-activities-view', params: { activitie: data.item.id,id: data.item.project_id} }">
                <feather-icon icon="FileTextIcon" />
                <span class="align-middle ml-50">Detalles</span>
              </b-dropdown-item>

          
            </b-dropdown>
          </template>


      </b-table>

  </b-card>
</template>

<script>
import BCardCode from '@core/components/b-card-code/BCardCode.vue'
import {
  BRow, BCol, BFormInput, BButton, BTable, BMedia, BAvatar, BLink,
  BBadge, BDropdown, BDropdownItem, BProgress,BCard,
} from 'bootstrap-vue'
export default {
  components: {
    BCardCode,
    BRow,
    BCol,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BProgress,
    BCard,


  },
  data() {
    return {
      fields: [
        // A virtual column that doesn't exist in items
        'index',
        // A column that needs custom formatting
        { key: 'name', label: 'Nombre' },
        { key: 'user_manager', label: 'Encargado' },
        // A regular column
        { key: 'progress', label: 'Progreso' },
        // A regular column
        { key: 'status', label: 'Estado' },
        // A virtual column made up from two fields
        { key: 'Actions', label: 'Actions' },
      ],
      activities: [],
      searchQuery:'',
      baseURL:'http://quantumdaily-back.test/storage/',

    }
  },
  methods:{
    getActivities(){
      this.$http.get('activities').then(res=>{
        this.activities = res.data.activities
      }).catch(err=>{
        console.log(err)
      })
    },
    
   deleteActivitie(activitie){
      this.$swal({
        title: '¿Está seguro de eliminar el registro?',
        text: "No podrás revertir esto!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonText: 'Si, eliminar!',
        customClass: {
          confirmButton: 'btn btn-primary',
          cancelButton: 'btn btn-outline-danger ml-1',
        },
        buttonsStyling: false,

      }).then(result => {
        if (result.value) {
          this.$http.get('project/activities/delete',{params:{activitie:activitie}}).then(res=>{
            this.$swal({
                icon: 'success',
                title: 'Eliminado!',
                text: 'El registro ha sido eliminado.',
                customClass: {
                  confirmButton: 'btn btn-success',
                },
              })
            this.getActivities()
          }).catch(err=>{
            console.log(err)
          })
      } else {
          this.$swal({
            title: 'Cancelado',
            text: 'El registro esta a salvo :)',
            icon: 'error',
            customClass: {
              confirmButton: 'btn btn-success',
            },
          })
        }
    })
    },
    statusVariant(status){
      if(status === 1){
        return 'secondary'
      }else if(status === 2){
        return 'info'
      }else if(status === 3){
        return 'success'
      }else if(status === 4){
        return 'warning'
      }else if(status === 5){
        return 'primary'
      }
    }, 
    percentageVariant(percentage){
      if(percentage <= 30){
        return 'primary'
      }else if(percentage > 30 && percentage <= 70){
        return 'warning'
      }else if(percentage > 70 && percentage < 100){
        return 'info'
      }else if(percentage === 100){
        return 'success'
      }
    }
  },
  mounted(){
    this.getActivities()
  }
  


}
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>

<style lang="scss">
@import '@core/scss/vue/libs/vue-select.scss';
</style>
